<template lang="pug">
b-table( :columns='columns' :data='orders' :loading='loading' )
	template( #receive='{item}' )
		.data.is-flex.is-flex-direction-column.is-align-items-flex-start.is-justify-content-flex-start
			p.date {{dayjs.utc(item.start).format("DD-MM-YYYY HH:mm")}}
			p.place {{item.receive}}
	template( #return='{item}' )
		.data.is-flex.is-flex-direction-column.is-align-items-flex-start.is-justify-content-flex-start
			p.date {{dayjs.utc(item.end).format("DD-MM-YYYY HH:mm")}}
			p.place {{item.return}}
	template( #member='{item}' )
		b-tooltip( v-if='item.Member' position="right" )
			b-button( type="link" size="small" light )
				span {{item.Member.name}}
				span.icon
					i.fa-solid.fa-arrow-right
			template( #content ): member-card( :member='item.Member' )
	template( #car='{item}' )
		b-button( v-if='item.Car' node="router-link" :to='{ name: "Car", params: { id: item.Car.id } }' type="link" size="small" light )
			span {{item.Car.name}}
			span.icon
				i.fa-solid.fa-arrow-right
		p.has-text-grey.is-size-small( v-else ) {{$t("default.car_deleted")}}
	template( #status='{item}' )
		.tag( :class='bindClass(item.status)' ) {{$t(`default.status.${item.status}`)}}
	template( #paid='{item}' )
		span.icon.is-small.has-text-success.is-flex( v-if='item.paid' )
			i.fa-solid.fa-check-square
		span.icon.is-small.has-text-danger.is-flex( v-else )
			i.fa-solid.fa-xmark-square
	template( #buttons='{ item }' )
		b-button( node="router-link" :to='{ name: "Order", params: { orderId: item.id } }' type="link" size="small" )
			span.icon
				i.fa-solid.fa-arrow-right
</template>

<script setup>
import BTable from "@/components/table/Table.vue"
import BTooltip from "@/components/Tooltip.vue"
import MemberCard from "@/components/orders/MemberCard.vue"

import { computed } from "vue"
import dayjs from "@/common/dayjs"

import { useI18n } from "vue-i18n"
import { statusClass } from "@/common/status"

const props = defineProps({
	orders: {
		type: Array,
		default: () => []
	},
	loading: Boolean,
	hasMember: Boolean
})

const { t } = useI18n()

const bindClass = computed(() => status => statusClass[status])

const columns = computed(() => {
	const data = [
		{ field: "id", label: "ID" },
		{ field: "receive", label: t("default.receive") },
		{ field: "return", label: t("default.return") }
	]

	if (props.hasMember)
		data.push(
			{ field: "member", label: t("default.member") }
		)

	data.push(
		{ field: "car", label: t("default.car") },
		{ field: "status", label: t("default.status.title") },
		{ field: "paid", label: t("default.paid") },
		{ field: "buttons" }
	)

	return data
})
</script>